SystemOrganization addCategory: #Unification!
SystemOrganization addCategory: #'Unification-Test'!

Object subclass: #UQuery
	instanceVariableNames: 'matchResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification'!

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
match: aSmallInteger 
	self shouldBeImplemented.! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
matchResult

	^ matchResult! !

!UQuery methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:37'!
unify: anObject

	matchResult := anObject.
	^true! !

TestCase subclass: #UnificatoinTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Unification-Test'!

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:37'!
testArray1

	| q1 q2 |
	q1 := UQuery new.
	q2 := UQuery new.
	
	self assert: ({q1. q2} unify: 'hi').
	self assert: $h equals: q1 matchResult.
	self assert: $i equals: q2 matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:29'!
testInteger

	| q |
	q := UQuery new.
	q unify: 1.
	self assert: 1 equals: q matchResult! !

!UnificatoinTest methodsFor: 'as yet unclassified' stamp: 'hjo 8/8/2012 17:30'!
testInteger2

	| q |
	q := UQuery new.
	q unify: 2.
	self assert: 2 equals: q matchResult! !

!SequenceableCollection methodsFor: '*Unification' stamp: 'hjo 8/8/2012 17:36'!
unify: aSequenceableCollection

	self size = aSequenceableCollection size ifFalse: [^false].
	1 to: self size do: [:index|  | unificationResult |
		unificationResult := (self at: index) unify: (aSequenceableCollection at: index).
		unificationResult ifFalse: [^false] ].
	^true	! !
